]> git.ipfire.org Git - thirdparty/git.git/blame - git-sh-setup.sh
config.txt: Make configuration paragraph more consistent
[thirdparty/git.git] / git-sh-setup.sh
CommitLineData
b33e9666
LT
1#!/bin/sh
2#
ae2b0f15
JH
3# This is included in commands that either have to be run from the toplevel
4# of the repository, or with GIT_DIR environment variable properly.
5# If the GIT_DIR does not look like the right correct git-repository,
6# it dies.
b33e9666 7
365527ad 8# Having this variable in your environment would break scripts because
e598c517 9# you would cause "cd" to be taken to unexpected places. If you
365527ad
JH
10# like CDPATH, define it for your interactive shell sessions without
11# exporting it.
12unset CDPATH
13
b33e9666 14die() {
8098a178 15 echo >&2 "$@"
b33e9666
LT
16 exit 1
17}
18
bac199b7
PH
19if test -n "$OPTIONS_SPEC"; then
20 usage() {
5d292756
JH
21 "$0" -h
22 exit 1
bac199b7
PH
23 }
24
e817e3e8
PH
25 parseopt_extra=
26 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
27 parseopt_extra="--keep-dashdash"
28
29 eval "$(
cbea86fd 30 echo "$OPTIONS_SPEC" |
e817e3e8
PH
31 git rev-parse --parseopt $parseopt_extra -- "$@" ||
32 echo exit $?
33 )"
bac199b7 34else
1b1dd23f 35 dashless=$(basename "$0" | sed -e 's/-/ /')
bac199b7 36 usage() {
1b1dd23f 37 die "Usage: $dashless $USAGE"
bac199b7
PH
38 }
39
40 if [ -z "$LONG_USAGE" ]
41 then
1b1dd23f 42 LONG_USAGE="Usage: $dashless $USAGE"
bac199b7 43 else
1b1dd23f 44 LONG_USAGE="Usage: $dashless $USAGE
bac199b7
PH
45
46$LONG_USAGE"
47 fi
48
49 case "$1" in
50 -h|--h|--he|--hel|--help)
51 echo "$LONG_USAGE"
52 exit
53 esac
54fi
d025524d 55
f9474132
SP
56set_reflog_action() {
57 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
58 then
59 GIT_REFLOG_ACTION="$*"
60 export GIT_REFLOG_ACTION
61 fi
62}
63
ef0c2abf 64git_editor() {
08874658
DK
65 : "${GIT_EDITOR:=$(git config core.editor)}"
66 : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
ef0c2abf
AR
67 case "$GIT_EDITOR,$TERM" in
68 ,dumb)
69 echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
70 echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
71 echo >&2 "Please set one of these variables to an appropriate"
72 echo >&2 "editor or run $0 with options that will not cause an"
73 echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
74 exit 1
75 ;;
76 esac
08874658 77 eval "${GIT_EDITOR:=vi}" '"$@"'
ef0c2abf
AR
78}
79
4b441f47 80is_bare_repository () {
5be60078 81 git rev-parse --is-bare-repository
4b441f47
JH
82}
83
9fde9401 84cd_to_toplevel () {
5be60078 85 cdup=$(git rev-parse --show-cdup)
9fde9401
JH
86 if test ! -z "$cdup"
87 then
2c3c395e
MC
88 # The "-P" option says to follow "physical" directory
89 # structure instead of following symbolic links. When cdup is
90 # "../", this means following the ".." entry in the current
91 # directory instead textually removing a symlink path element
92 # from the PWD shell variable. The "-P" behavior is more
93 # consistent with the C-style chdir used by most of Git.
94 cd -P "$cdup" || {
95 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
9fde9401
JH
96 exit 1
97 }
98 fi
99}
100
7eff28a9 101require_work_tree () {
e90fdc39 102 test $(git rev-parse --is-inside-work-tree) = true ||
7eff28a9
SP
103 die "fatal: $0 cannot be used without a working tree."
104}
105
0cae2346
JS
106get_author_ident_from_commit () {
107 pick_author_script='
108 /^author /{
109 s/'\''/'\''\\'\'\''/g
110 h
111 s/^author \([^<]*\) <[^>]*> .*$/\1/
112 s/'\''/'\''\'\'\''/g
113 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
114
115 g
116 s/^author [^<]* <\([^>]*\)> .*$/\1/
117 s/'\''/'\''\'\'\''/g
118 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
119
120 g
121 s/^author [^<]* <[^>]*> \(.*\)$/\1/
122 s/'\''/'\''\'\'\''/g
123 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
124
125 q
126 }
127 '
128 encoding=$(git config i18n.commitencoding || echo UTF-8)
077b725f 129 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
0cae2346
JS
130 LANG=C LC_ALL=C sed -ne "$pick_author_script"
131}
132
22c90717
JH
133# Make sure we are in a valid repository of a vintage we understand,
134# if we require to be in a git repository.
70087cdb 135if test -z "$NONGIT_OK"
d025524d 136then
4d6d6d2d 137 GIT_DIR=$(git rev-parse --git-dir) || exit
22c90717
JH
138 if [ -z "$SUBDIRECTORY_OK" ]
139 then
22c90717
JH
140 test -z "$(git rev-parse --show-cdup)" || {
141 exit=$?
142 echo >&2 "You need to run this command from the toplevel of the working tree."
143 exit $exit
144 }
22c90717
JH
145 fi
146 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
147 echo >&2 "Unable to determine absolute path of git directory"
148 exit 1
b2bc9a30 149 }
22c90717 150 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
d025524d 151fi
87bddba9
JS
152
153# Fix some commands on Windows
154case $(uname -s) in
155*MINGW*)
156 # Windows has its own (incompatible) sort and find
157 sort () {
158 /usr/bin/sort "$@"
159 }
160 find () {
161 /usr/bin/find "$@"
162 }
163 ;;
164esac